/** @file
 * VirtualBox API class wrapper header for ICloudNetwork.
 *
 * DO NOT EDIT! This is a generated file.
 * Generated from: src/VBox/Main/idl/VirtualBox.xidl
 * Generator: src/VBox/Main/idl/apiwrap-server.xsl
 */

/*
 * Copyright (C) 2010-2020 Oracle Corporation
 *
 * This file is part of VirtualBox Open Source Edition (OSE), as
 * available from http://www.virtualbox.org. This file is free software;
 * you can redistribute it and/or modify it under the terms of the GNU
 * General Public License (GPL) as published by the Free Software
 * Foundation, in version 2 as it comes in the "COPYING" file of the
 * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 */

#ifndef CloudNetworkWrap_H_
#define CloudNetworkWrap_H_
#ifndef RT_WITHOUT_PRAGMA_ONCE
# pragma once
#endif

#include "VirtualBoxBase.h"
#include "Wrapper.h"

class ATL_NO_VTABLE CloudNetworkWrap
    : public VirtualBoxBase
    , VBOX_SCRIPTABLE_IMPL(ICloudNetwork)
{
    Q_OBJECT

public:
    VIRTUALBOXBASE_ADD_ERRORINFO_SUPPORT(CloudNetworkWrap, ICloudNetwork)
    DECLARE_NOT_AGGREGATABLE(CloudNetworkWrap)
    DECLARE_PROTECT_FINAL_CONSTRUCT()

    BEGIN_COM_MAP(CloudNetworkWrap)
        COM_INTERFACE_ENTRY(ISupportErrorInfo)
        COM_INTERFACE_ENTRY(ICloudNetwork)
        COM_INTERFACE_ENTRY2(IDispatch, ICloudNetwork)
        VBOX_TWEAK_INTERFACE_ENTRY(ICloudNetwork)
    END_COM_MAP()

    DECLARE_EMPTY_CTOR_DTOR(CloudNetworkWrap)

    /** @name Public ICloudNetwork properties
     * @{ */
    STDMETHOD(COMGETTER(NetworkName))(BSTR *aNetworkName);
    STDMETHOD(COMSETTER(NetworkName))(IN_BSTR aNetworkName);
    STDMETHOD(COMGETTER(Enabled))(BOOL *aEnabled);
    STDMETHOD(COMSETTER(Enabled))(BOOL aEnabled);
    STDMETHOD(COMGETTER(Provider))(BSTR *aProvider);
    STDMETHOD(COMSETTER(Provider))(IN_BSTR aProvider);
    STDMETHOD(COMGETTER(Profile))(BSTR *aProfile);
    STDMETHOD(COMSETTER(Profile))(IN_BSTR aProfile);
    STDMETHOD(COMGETTER(NetworkId))(BSTR *aNetworkId);
    STDMETHOD(COMSETTER(NetworkId))(IN_BSTR aNetworkId);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute1ICloudNetwork))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute2ICloudNetwork))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute3ICloudNetwork))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute4ICloudNetwork))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute5ICloudNetwork))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute6ICloudNetwork))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute7ICloudNetwork))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute8ICloudNetwork))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute9ICloudNetwork))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute10ICloudNetwork))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute11ICloudNetwork))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute12ICloudNetwork))(ULONG *aReserved);
    /** @} */

    /** @name Public ICloudNetwork methods
     * @{ */
    STDMETHOD(InternalAndReservedMethod1ICloudNetwork)();
    STDMETHOD(InternalAndReservedMethod2ICloudNetwork)();
    STDMETHOD(InternalAndReservedMethod3ICloudNetwork)();
    STDMETHOD(InternalAndReservedMethod4ICloudNetwork)();
    /** @} */

private:
    /** @name Wrapped ICloudNetwork properties
     * @{ */
    virtual HRESULT getNetworkName(com::Utf8Str &aNetworkName) = 0;
    virtual HRESULT setNetworkName(const com::Utf8Str &aNetworkName) = 0;
    virtual HRESULT getEnabled(BOOL *aEnabled) = 0;
    virtual HRESULT setEnabled(BOOL aEnabled) = 0;
    virtual HRESULT getProvider(com::Utf8Str &aProvider) = 0;
    virtual HRESULT setProvider(const com::Utf8Str &aProvider) = 0;
    virtual HRESULT getProfile(com::Utf8Str &aProfile) = 0;
    virtual HRESULT setProfile(const com::Utf8Str &aProfile) = 0;
    virtual HRESULT getNetworkId(com::Utf8Str &aNetworkId) = 0;
    virtual HRESULT setNetworkId(const com::Utf8Str &aNetworkId) = 0;
    /** @} */

    /** @name Wrapped ICloudNetwork methods
     * @{ */
    /** @} */

private:
    DECLARE_CLS_COPY_CTOR_ASSIGN_NOOP(CloudNetworkWrap); /* Shuts up MSC warning C4625. */

};

#endif // !CloudNetworkWrap_H_
